javax.ejb

## Annotation Type EJB

-     @Target(value={TYPE,METHOD,FIELD})
      @Retention(value=RUNTIME)
      public @interface EJB

  Indicates a dependency on the local, no-interface, or remote view of an Enterprise JavaBean.

  Either the `beanName` or the `lookup` element can be used to resolve the EJB dependency to its target session bean component. It is an error to specify values for both `beanName` and `lookup`.

  If no explicit linking information is provided and there is only one session bean within the same application that exposes the matching client view type, by default the EJB dependency resolves to that session bean.

  Since:
    EJB 3.0

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `Class` | `beanInterface` The interface type of the Enterprise Java Bean to which this reference is mapped.
    `String` | `beanName` The `beanName` element references the value of the `name` element of the `Stateful` or `Stateless` annotation, whether defaulted or explicit.
    `String` | `description` A string describing the bean.
    `String` | `lookup` A portable lookup string containing the JNDI name for the target EJB component.
    `String` | `mappedName` The product specific name of the EJB component to which this ejb reference should be mapped.
    `String` | `name` The logical name of the ejb reference within the declaring component's (e.g., java:comp/env) environment.

- - ### Element Detail

    - #### name

          public abstract String name

      The logical name of the ejb reference within the declaring component's (e.g., java:comp/env) environment.
      Default:
        ""

    - #### description

          public abstract String description

      A string describing the bean.
      Default:
        ""

    - #### beanName

          public abstract String beanName

      The `beanName` element references the value of the `name` element of the `Stateful` or `Stateless` annotation, whether defaulted or explicit. If the deployment descriptor was used to define the name of the bean, the `beanName` element references the `ejb-name` element of the bean definition.

      The `beanName` element allows disambiguation if multiple session beans in the ejb-jar implement the same interface.

      In order to reference a bean in another ejb-jar file in the same application, the `beanName` may be composed of a path name specifying the ejb-jar containing the referenced bean with the bean name of the target bean appended and separated from the path name by #. The path name is relative to the jar file containing the component that is referencing the target bean.

      Only applicable if the target EJB is defined within the same application or stand-alone module as the declaring component.

      Default:
        ""

    - #### beanInterface

          public abstract Class beanInterface

      The interface type of the Enterprise Java Bean to which this reference is mapped.

      Holds one of the following types of the target EJB :

      - Local business interface
      - Bean class (for no-interface view)
      - Remote business interface
      - Local Home interface
      - Remote Home interface
      Default:
        java.lang.Object.class

    - #### mappedName

          public abstract String mappedName

      The product specific name of the EJB component to which this ejb reference should be mapped. This mapped name is often a global JNDI name, but may be a name of any form.

      Application servers are not required to support any particular form or type of mapped name, nor the ability to use mapped names. The mapped name is product-dependent and often installation-dependent. No use of a mapped name is portable.

      Default:
        ""

    - #### lookup

          public abstract String lookup

      A portable lookup string containing the JNDI name for the target EJB component.
      Since:
        EJB 3.1
      Default:
        ""

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.